Index: /trunk/contactcenter/inc/class.ThreadInstance.inc.php
===================================================================
--- /trunk/contactcenter/inc/class.ThreadInstance.inc.php	(revision 284)
+++ /trunk/contactcenter/inc/class.ThreadInstance.inc.php	(revision 284)
@@ -0,0 +1,55 @@
+<?php
+	/***********************************************************************************\
+	* eGroupWare - Contacts Center                                              		*
+	* http://www.egroupware.org                                                 		*
+	* Written by:                                                               		*
+	*  - Brian W. Bosh from	Multi-threading strategies in PHP at						*
+	* http://www.alternateinterior.com/2007/05/multi-threading-strategies-in-php.html	*
+	* Adapted by:																		*
+	*  - Mário César Kolling <mario.kolling@serpro.gov.br>								*
+	* ----------------------------------------------------------------------------------*
+	*  This program is free software; you can redistribute it and/or modify it  		*
+	*  under the terms of the GNU General Public License as published by the    		*
+	*  Free Software Foundation; either version 2 of the License, or (at your   		*
+	*  option) any later version.                                               		*
+	\***********************************************************************************/
+
+	set_time_limit (0);
+	require 'ThreadUtility.inc.php';
+
+	/*
+	 * A class that is extended by the new php process and deals with communication at the new php process side
+	 */
+
+	class ThreadInstance {
+		var $stdin;
+		var $stdout;
+
+		function setup() {
+			$this->stdin = fopen ("php://stdin", "r");
+			$this->stderr = fopen ("php://stderr", "w");
+			stream_set_blocking ($this->stdin, false);
+		}
+		function getCommand() {
+				return $this->getLine(true);
+		}
+		function response ($status, $data) {
+			response ($status, $data);
+		}
+		function getLine ($wait = false) {
+			if ($wait) {
+				$buffer = "";
+				while (!strlen($buffer)) {
+					$buffer .= fgets ($this->stdin, 1024);
+				}
+			} else {
+				$buffer = fgets ($this->stdin, 1024);
+			}
+			return trim($buffer);
+		}
+		function debug ($text) {
+			fwrite ($this->stderr, $text);
+		}
+	}
+
+?>
Index: /trunk/contactcenter/inc/class.so_contact.inc.php
===================================================================
--- /trunk/contactcenter/inc/class.so_contact.inc.php	(revision 203)
+++ /trunk/contactcenter/inc/class.so_contact.inc.php	(revision 284)
@@ -110,14 +110,4 @@
 				'is_global'		=> array(
 					'name'		=> 'is_global',
-					'type'		=> false,
-					'state'		=> 'empty',
-					'value'		=> false),
-				'last_status'		=> array(
-					'name'		=> 'last_status',
-					'type'		=> false,
-					'state'		=> 'empty',
-					'value'		=> false),
-				'last_update'		=> array(
-					'name'		=> 'last_update',
 					'type'		=> false,
 					'state'		=> 'empty',
Index: /trunk/contactcenter/inc/class.bo_people_catalog.inc.php
===================================================================
--- /trunk/contactcenter/inc/class.bo_people_catalog.inc.php	(revision 203)
+++ /trunk/contactcenter/inc/class.bo_people_catalog.inc.php	(revision 284)
@@ -1417,6 +1417,4 @@
 			if ($altered)
 			{
-				$contact->set_field("last_status", 'U');
-				$contact->set_field("last_update",time()."000");
 				return $contact->commit();
 			}
Index: /trunk/contactcenter/inc/class.ui_api.inc.php
===================================================================
--- /trunk/contactcenter/inc/class.ui_api.inc.php	(revision 203)
+++ /trunk/contactcenter/inc/class.ui_api.inc.php	(revision 284)
@@ -18,14 +18,14 @@
 	 *
 	 */
-  
+
 	class ui_api
 	{
 		var $commons;
 		var $commons_loaded = false;
-		
+
 		function ui_api()
 		{
 			$preferences = ExecMethod('contactcenter.ui_preferences.get_preferences');
-			
+
 			if (!is_array($preferences))
 			{
@@ -33,17 +33,15 @@
 				//$preferences['personCardPhone'] = 2;
 			}
-			
-			//$template_dir = PHPGW_SERVER_ROOT . '/contactcenter/templates/default/';
-			//$template = CreateObject('phpgwapi.Template',$template_dir);
-			$template = CreateObject('phpgwapi.Template',PHPGW_APP_TPL);
+
+			$template_dir = PHPGW_SERVER_ROOT . '/contactcenter/templates/default/';
+			$template = CreateObject('phpgwapi.Template',$template_dir);
 
 			$template->set_file(array('api' => 'api_common.tpl'));
-			
+
 			$template->set_var('cc_email_id_type', $preferences['personCardEmail']);
-			
-			
+
 			/* Messages */
 			$template->set_var('cc_msg_err_invalid_catalog',lang('Unavailable or empty Catalog'));
-			$template->set_var('cc_msg_err_contacting_server',lang('Couldn\'t contact server or server response is invalid. Contact Admin.'));
+			$template->set_var('cc_msg_err_contacting_server',lang('Couldn\'t contact server or server response is invalid.'));
 			$template->set_var('cc_msg_err_timeout',lang('Operation Timed Out.'));
 			$template->set_var('cc_msg_err_serialize_data_unknown',lang('Data to be serialized is of unknown type!'));
@@ -77,5 +75,5 @@
 			$template->set_var('cc_js_djswin', $GLOBALS['phpgw_info']['server']['webserver_url'] . '/phpgwapi/js/dJSWin/dJSWin.js');
 			$template->set_var('cc_js_catalog_tree', $GLOBALS['phpgw_info']['server']['webserver_url'] . '/contactcenter/js/cc_tree.js');
-			
+
 			$template->parse('out','api');
 
@@ -83,5 +81,5 @@
 			$this->commons_loaded = false;
 		}
-		
+
 		/* DEPRECTED! Use get_email_win() instead */
 		function ui_get_email_win()
@@ -93,10 +91,10 @@
 		{
 			//$search = $this->ui_get_search_win();
-			
+
 			$template_dir = PHPGW_SERVER_ROOT . '/contactcenter/templates/default/';
 			$template = CreateObject('phpgwapi.Template', $template_dir);
 
 			$template->set_file(array('email_win' => 'email_win.tpl'));
-			
+
 			if (!$this->commons_loaded)
 			{
@@ -108,17 +106,17 @@
 				$template->set_var('cc_api', '');
 			}
-			
+
 			//$template->set_var('cc_search_win', $search);
 			$template->set_var('cc_js_search', $GLOBALS['phpgw_info']['server']['webserver_url'] . '/contactcenter/js/cc_search.js');
-			
+
 			$template->set_var('cc_email_id_type', $search);
-			
+
 			$template->set_var('cc_email_win_title',lang('Contact Center').' - '.lang('Catalog Entries Emails'));
 			$template->set_var('cc_email_status',lang('Status').':');
 			$template->set_var('cc_email_search_text',lang('Search').'...');
-			
+
 			$template->set_var('cc_choose_catalogue',lang('Choose a catalogue').'...');
 			$template->set_var('cc_choose_ordinance',lang('Choose a ordinance').'...');
-			
+
 			$template->set_var('cc_btn_to_add',lang('To').' >>');
 			$template->set_var('cc_btn_to_del','<< '.lang('To'));
@@ -132,5 +130,5 @@
 			$template->set_var('cc_btn_ok',lang('Ok'));
 			$template->set_var('cc_btn_cancel',lang('Cancel'));
-			
+
 			$template->set_var('cc_label_to',lang('To').':');
 			$template->set_var('cc_label_cc',lang('Cc').':');
@@ -140,9 +138,9 @@
 			$template->set_var('cc_label_catalogue_type',lang('Type Of Catalogue').':');
 			$template->set_var('cc_label_ordinance_type',lang('Type Of Ordinace').':');
-			
+
 			$template->set_var('phpgw_img_dir', $GLOBALS['phpgw_info']['server']['webserver_url'] . '/phpgwapi/images');
-			
+
 			$template->set_var('cc_js_email_win', $GLOBALS['phpgw_info']['server']['webserver_url'] . '/contactcenter/js/cc_email_win.js');
-			
+
 			$template->parse('out','email_win');
 
@@ -161,5 +159,5 @@
 
 			$template->set_file(array('search' => 'search_win.tpl'));
-			
+
 			if (!$this->commons_loaded)
 			{
@@ -171,5 +169,5 @@
 				$template->set_var('cc_api', '');
 			}
-			
+
 			$template->set_var('cc_search_title',lang('Contact Center - Search for Catalog Entries'));
 			$template->set_var('cc_search_minimize',lang('Minimize'));
@@ -180,9 +178,9 @@
 			$template->set_var('cc_search_go',lang('Go'));
 			$template->set_var('cc_search_cancel',lang('Cancel'));
-			
+
 			$template->set_var('cc_js_search_win', $GLOBALS['phpgw_info']['server']['webserver_url'] . '/contactcenter/js/cc_search_win.js');
-			
+
 			$template->set_var('phpgw_img_dir', $GLOBALS['phpgw_info']['server']['webserver_url'] . '/phpgwapi/images');
-			
+
 			$template->parse('out','search');
 
@@ -205,5 +203,5 @@
 
 			$template->set_file(array('full_add' => 'full_add.tpl'));
-			
+
 			if (!$this->commons_loaded)
 			{
@@ -215,5 +213,5 @@
 				$template->set_var('cc_api', '');
 			}
-			
+
 			$template->set_var('cc_contact_title',lang('Contact Center').' - '.lang('Contacts'));
 
@@ -223,5 +221,5 @@
 			$template->set_var('cc_msg_type_city',lang('Type new city here').'...');
 			/* End Messages */
-			
+
 			/* Contact */
 			$template->set_var('cc_contact_save',lang('Save'));
@@ -232,12 +230,9 @@
 			$template->set_var('cc_contact_addrs',lang('Addresses'));
 			$template->set_var('cc_contact_conns',lang('Connections'));
-			$template->set_var('emails_telephones', lang("E-Mails and Telephones"));
-			$template->set_var('cc_default', lang("Default"));
-
 			/* End Contact */
-			
+
 			/* Contact - Personal Data */
 			$dateformat = $GLOBALS['phpgw_info']['user']['preferences']['common']['dateformat'];
-		
+
 			$j = 0;
 			for ($i = 0; $i < 5; $i+=2)
@@ -262,9 +257,9 @@
 				$j++;
 			}
-			
+
 			$template->set_var('cc_pd_birth_size_0', "{$date[0]['size']}");
 			$template->set_var('cc_pd_birth_size_1', "{$date[1]['size']}");
 			$template->set_var('cc_pd_birth_size_2', "{$date[2]['size']}");
-			
+
 			$template->set_var('cc_pd_birthdate_0', "{$date[0]['name']}");
 			$template->set_var('cc_pd_birthdate_1', "{$date[1]['name']}");
@@ -273,5 +268,5 @@
 			$template->set_var('cc_pd_select_photo_b', lang('Browse').'...');
 			$template->set_var('cc_form_photo_src', 'photo_form.html');
-			
+
 			$template->set_var('cc_pd_select_photo',lang('Select Photo'));
 			$template->set_var('cc_pd_alias',lang('Alias'));
@@ -291,5 +286,5 @@
 			$template->set_var('cc_pd_female',lang('Female'));
 			/* End Contact - Personal Data */
-			
+
 			/* Contact - Addresses */
 			$template->set_var('cc_addr_types',lang('Type of Address'));
@@ -315,20 +310,15 @@
 			$template->set_var('cc_available',lang('Available'));
 			/* End Contact - Addresses */
-			
-			
+
 			/* Contact - Connections */
 			$template->set_var('cc_conn_type',lang('Type of Connection'));
 			$template->set_var('cc_conn_name',lang('Connection Name'));
 			$template->set_var('cc_conn_value',lang('Connection Value'));
-			
+
 			$template->set_var('cc_new_same_type',lang('New from the same Type').'...');
-			
+
 			$template->set_var('cc_conn_type_none',lang('Choose Type of Connection').'...');
 			/* End Contact - Connections */
 
-			$template->set_var('email', lang("E-Mail"));
-			$template->set_var('telephone', lang("Telephone"));
-			$template->set_var('choose_email_telephone', lang("Choose 'E-Mail' or 'Telephone'"));
-
 			$template->parse('out_full', 'full_add');
 
@@ -342,5 +332,5 @@
 
 			$template->set_file(array('quickAdd' => 'quickAddPlugin.tpl'));
-			
+
 			if (!$this->commons_loaded)
 			{
@@ -352,5 +342,5 @@
 				$template->set_var('cc_api', '');
 			}
-			
+
 			$template->set_var('ccQAPluginFile', $GLOBALS['phpgw_info']['server']['webserver_url'] . '/contactcenter/js/ccQuickAdd-plugin.js');
 
@@ -360,13 +350,13 @@
 			$nFields = 5;
 			$fields = array(
-				lang('Alias'), 
-				lang('Given Names'), 
-				lang('Family Names'), 
+				lang('Alias'),
+				lang('Given Names'),
+				lang('Family Names'),
 				lang('Phone'),
 				lang('Email')
 			);
-			
+
 			$template->set_var('ccQAnFields', $nFields);
-			
+
 			$fieldsHTML = '';
 			$fieldsTop = 10;
@@ -375,5 +365,13 @@
 			{
 				$fieldsHTML .= '<span id="ccQuickAddT'.$i.'" style="position: absolute; top: '.($fieldsTop+$i*$fieldsSpace).'px; left: 5px; width: 100px; text-align: right; border: 0px solid #999;">'.$fields[$i].':</span>'."\n";
-				$fieldsHTML .= '<input id="ccQuickAddI'.$i.'" type="text" value="" maxlength="50" style="position: absolute; top: '.($fieldsTop+$i*$fieldsSpace).'px; left: 110px; width: 135px;">'."\n";
+				if ($i == 0){
+					$fieldsHTML .= '<input id="ccQuickAddI'.$i.'" type="text" value="" maxlength="30" style="position: absolute; top: '.($fieldsTop+$i*$fieldsSpace).'px; left: 110px; width: 135px;">'."\n";
+				}
+				else if ($i == 4){
+					$fieldsHTML .= '<input id="ccQuickAddI'.$i.'" type="text" value="" maxlength="100" style="position: absolute; top: '.($fieldsTop+$i*$fieldsSpace).'px; left: 110px; width: 135px;">'."\n";
+				}
+				else {
+					$fieldsHTML .= '<input id="ccQuickAddI'.$i.'" type="text" value="" maxlength="50" style="position: absolute; top: '.($fieldsTop+$i*$fieldsSpace).'px; left: 110px; width: 135px;">'."\n";
+				}
 			}
 
@@ -381,8 +379,8 @@
 			$template->set_var('ccQAWinHeight', ($i+1)*$fieldsSpace+$fieldsTop);
 			$template->set_var('ccQAFunctionsTop', ($fieldsTop+$i*$fieldsSpace).'px');
-			
+
 			/* Images Dir */
 			$template->set_var('ccQACardImgRoot', $GLOBALS['phpgw_info']['server']['webserver_url'].'/contactcenter/templates/default/images/');
-			
+
 			/* Texts */
 			$template->set_var('ccQATitle', lang('Contact Center').' - '.lang('Quick Add'));
@@ -390,10 +388,10 @@
 			$template->set_var('ccQAClear', lang('Reset'));
 			$template->set_var('ccQACancel', lang('Cancel'));
-			
+
 			$template->parse('out_QA', 'quickAdd');
 
 			return $template->get_var('out_QA');
 		}
-		
+
 		function get_add_group()
 		{
@@ -402,5 +400,5 @@
 
 			$template->set_file(array('addGroup' => 'addGroup.tpl'));
-			
+
 			if (!$this->commons_loaded)
 			{
@@ -410,15 +408,15 @@
 			else
 			{
-				
+
 				$template->set_var('cc_api', '');
 			}
-			
-			$template->set_var('ccAGFile', $GLOBALS['phpgw_info']['server']['webserver_url'] . '/contactcenter/js/ccAddGroup.js');			
-			$template->set_var('ccAGWinHeightIE', '285');			
+
+			$template->set_var('ccAGFile', $GLOBALS['phpgw_info']['server']['webserver_url'] . '/contactcenter/js/ccAddGroup.js');
+			$template->set_var('ccAGWinHeightIE', '285');
 			$template->set_var('ccAGWinHeightMO', '335');
-			
+
 			/* Images Dir */
 			$template->set_var('ccAGCardImgRoot', $GLOBALS['phpgw_info']['server']['webserver_url'].'/contactcenter/templates/default/images/');
-			
+
 			/* Texts */
 			$template->set_var('ccAGTitle', lang('Contact Center').' - '.lang('Group Add'));
@@ -426,20 +424,20 @@
 			$template->set_var('ccAGClear', lang('Reset'));
 			$template->set_var('ccAGCancel', lang('Cancel'));
-			$title = '<input type="text" id="title" name="title" value="'.$group['title'].'" size="50" maxlength="50"/>';			
-				
-			$template->set_var('title', $title);												
+			$title = '<input type="text" id="title" name="title" value="'.$group['title'].'" size="50" maxlength="50"/>';
+
+			$template->set_var('title', $title);
 			// set content and label variables.
 			$template->set_var(array(
-						'msg_text' 	=> lang($status),						
-						'txt_title' 	=> lang('Contact Group List'),						
+						'msg_text' 	=> lang($status),
+						'txt_title' 	=> lang('Contact Group List'),
 						'txt_cancel'=> lang('cancel'),
-						'txt_add'=> lang('Add'),						
+						'txt_add'=> lang('Add'),
 						'txt_rem'=> lang('Remove'),
 						'txt_personal_contacts' => lang('Personal Contacts'),
 						'txt_contacts_in_list' => lang("Participants"),
 						'txt_name'	=> lang('Full Name')));
-						
+
 			$template->parse('out_AG', 'addGroup');
-			
+
 			return $template->get_var('out_AG');
 		}
